<?php

/**
 * Backend helper class for ajax long request
 * @author Alek$ <aleks@aradmin.org.ru> http://nevkontakte.org.ru
 */

class LongRequest
{
	private static $id = 0;
	private static $buffer = "";

	private function __construct()
	{
	
	}
/**
 * Init long request helper
 * 
 * Start output buffering, set request id, etc.
 */

	
	public static function init()
	{
		self::$id = intval($_REQUEST['LongRequestId']);
		ob_start(array('LongRequest', 'finalize'));
		set_time_limit(0);
	}

/**
 * Send $data to browser
 * 
 * String will be represented as string, numeric types as numeric, null as null, array will be converted to hash, object sill be serialize and passed as string.
 * @param mixed $data Data to pass
 */

	
	public static function send($data)
	{
		static $count = 0;
		if(self::$id == 0)
		{
			throw new ExLRInit();
		}
		
		self::obPause();
		echo 'qwe<script type="text/javascript">';
		echo 'window.parent.lreq.callback(' . ($count>0?'1':'0') . ', '.self::$id.', '.self::dataToHash($data).');';
		echo "</script>\n";
		self::obResume();
		$count++;
	}

/**
 * Script output buffer handler
 * 
 * Is called automatically on exit
 * @param string $buffer Output buffer contents
 * @param int $mode Flags
 */

	
	public static function finalize($buffer, $mode)
	{
		if($mode&PHP_OUTPUT_HANDLER_END)
		{
			self::$buffer .= $buffer;
			$echo  = 'qwe<script type="text/javascript">';
			$echo .= 'window.parent.lreq.callback(2, '.self::$id.', null, '.self::dataToHash(self::$buffer).');';
			$echo .= '</script>';
			
			return $echo;
		}
		else
		{
			return $buffer;
		}
	}

/**
 * Resume output buffering after sending a message to browser
 */

	
	private static function obResume()
	{
		ob_flush();
		ob_clean();
		flush();
	}

/**
 * Pause output buffering before sending a message
 */

	
	private static function obPause()
	{
		self::$buffer .= ob_get_contents();
		ob_clean();
	}

/**
 * Convert variable to corresponding JavaScript type
 * @param mixed $data Data to convert
 */

	
	private static function dataToHash($data)
	{
		if(is_numeric($data))
		{
			return $data;
		}
		else if(is_string($data))
		{
			return '"' . str_replace("\n", "\\n", htmlspecialchars(addslashes($data), ENT_NOQUOTES)) . '"';
		}
		else if(is_array($data))
		{
			return self::arrayToHash($data);
		}
		else if(is_null($data))
		{
			return 'null';
		}
		else
		{
			return '"' . htmlspecialchars(addslashes(serialize($data)), ENT_NOQUOTES) . '"';
		}
	}

/**
 * Convert array to hash
 * @param mixed $array
 */

	
	private static function arrayToHash($array)
	{
		$hash = array();
		foreach($array as $key => $value)
		{
			$hash[] = '"' . htmlspecialchars($key) . '": ' . self::dataToHash($value);
		}
		
		return '{'.implode(', ', $hash).'}';
	}
}

/**
 * LongRequest is not initilized bfore sending a message to browser
 */


class ExLRInit extends Exception {}
?>